/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.controllers.dict


import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.Opt
import com.persagy.server.datacenter.models.entities.dictnew.DefFuncId
import com.persagy.server.datacenter.models.jms.SynchronousMessage
import com.persagy.server.service.dict.DictDefClassService
import com.persagy.service.SObjectService
import com.persagy.service.models.requests.SCountRequest
import com.persagy.service.models.responses.SCountResponse
import com.persagy.service.models.responses.SQueryResponse
import io.swagger.v3.oas.annotations.Operation
import io.swagger.v3.oas.annotations.tags.Tag
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

/**
 * 项目化字典
 *
 * @author 张维新
 */
@Tag(name = "项目化字典")
@RestController
@RequestMapping("/dict")
class DictCustomController {

    /** 缓存对象数据服务 - 数据中心到数据中台  */
    var synchronousMessageObjService = SObjectService(SMybatisDao(SynchronousMessage::class.java))
    /**
     * 项目化字典类型
     */
//   @Operation(summary = "项目化字典 - 统计数量", description = "")
//    @PostMapping(value = ["/project-dict-count"])
//    fun  projectDictCount(@RequestBody request: SCountRequest): SCountResponse {
//        return DictDatacenterProjectcustomService.counts(request)
//    } // Function  projectDictCount

    /**
     * 需补充转换规则数量
     */
//   @Operation(summary = "项目化字典 - 需补充转换规则数量", description = "")
//    @PostMapping(value = ["/project-dict-switch-count"])
//    fun  projectDictSwitchRuleCount(): SCountResponse{
//        return DictDatacenterProjectcustomService.projectDictSwitchRuleCounts()
//    } // Function  projectDictSwitchRuleCount


    /**
     * 项目化字典类型
     */
//   @Operation(summary = "项目化字典 - 内容", description = "")
//    @PostMapping(value = ["/project-dict-info"])
//    fun  projectDictInfo(@RequestBody request: SQueryRequest): SQueryResponse<DictDatacenterProjectcustom> {
//        return DictDatacenterProjectcustomService.queryDict(request)
//    } // Function  projectDictCount()

    /**
     * 数据中心-物理世界数据转换
     */
//   @Operation(summary = "数据中心-物理世界数据转换 ", description = "")
//    @PostMapping(value = ["/project-dict-datacenter"])
//    fun dataCenterDataPlatform(): SQueryResponse<EquipDictStatistics>{
//       return DictDatacenterProjectcustomService.equipStatisticsDataCenter()
//    } // Function dataCenterDataPlatform ()

    /**
     * 物理世界 - 数据中心数据转换
     */
//   @Operation(summary = "物理世界-数据中心数据转换 ", description = "")
//    @PostMapping(value = ["/project-dict-dataplatfrom"])
//    fun dataPlatformdataCenter(): SQueryResponse<EquipDictStatistics>{
//        return DictDatacenterProjectcustomService.equipStatisticsDataPlatfrom()
//    } // Function dataCenterDataPlatform ()


//   @Operation(summary = "更新自定义自定脚本", description = "")
//    @PostMapping(value = ["/update"])
//    fun update(@RequestBody request: ArrayList<DictDatacenterProjectcustom>): SBaseResponse {
//
//        return DictDatacenterProjectcustomService.updateDictSwitchRule(request)
//    } // Function upDate

    /**
     * 查询 M 和 L 类型的信息点
     */
    @Operation(summary = "字典-查询所有字典信息 M 和 L 类型,包括自定义信息点", description = "project (项目),building (建筑),floor (楼层),equipment (设备),system(系统),component (部件),space (空间)")
    @PostMapping(value = ["/morl/query"])
    fun queryMOrL(@RequestBody dictTypeList: ArrayList<String>): SQueryResponse<DefFuncId> {
        return DictDefClassService.queryMOrL(dictTypeList)
    }

    /**
     * 获取不能同步到物理世界对象的数量
     */
    @Operation(summary = "获取不能同步到物理世界对象的数量", description = "")
    @PostMapping(value = ["/data-count"])
    fun objectCounts(@RequestBody request: SCountRequest): SCountResponse {
        val messageList =
            synchronousMessageObjService.select(SFilter.eq("projectId", Opt.projectId!!),SFilter.not(SFilter.eq("sign", 2))).order("createTime").exec()
        return SCountResponse(messageList.size.toLong())
    }  // Function objectCounts()



} //